﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace _462041DDLbinding
{
    public partial class RadForm1 : Telerik.WinControls.UI.RadForm
    {
        Student student;

        public RadForm1()
        {
            InitializeComponent();
        }

        private void RadForm1_Load(object sender, EventArgs e)
        {
            this.productsTableAdapter.Fill(this.nwindDataSet.Products);

            this.radDropDownList1.DataSource = this.productsBindingSource;
            this.radDropDownList1.DisplayMember = "ProductName";
            this.radDropDownList1.ValueMember = "ProductID";

            student = new Student(3, "Student3");
            this.radDropDownList1.DataBindings.Add("SelectedValue", student, "Id", false, DataSourceUpdateMode.OnPropertyChanged);
            this.radDropDownList1.DropDownStyle = Telerik.WinControls.RadDropDownStyle.DropDownList;
        }

        public class Student : System.ComponentModel.INotifyPropertyChanged
        {
            int m_id;
            string m_name;

            public event PropertyChangedEventHandler PropertyChanged;

            public Student(int m_id, string m_name)
            {
                this.m_id = m_id;
                this.m_name = m_name;
            }

            public int Id
            {
                get
                {
                    return m_id;
                }
                set
                {
                    if (this.m_id != value)
                    {
                        this.m_id = value;
                        OnPropertyChanged("Id");
                    }
                }
            }

            public string Name
            {
                get
                {
                    return m_name;
                }
                set
                {
                    if (this.m_name != value)
                    {
                        this.m_name = value;
                        OnPropertyChanged("Name");
                    }
                }
            }

            protected virtual void OnPropertyChanged(string propertyName)
            {
                if (PropertyChanged != null)
                {
                    PropertyChanged(this, new PropertyChangedEventArgs(propertyName));
                }
            }
        }
        Random rand = new Random();
        private void radButton1_Click(object sender, EventArgs e)
        {
            student.Id = rand.Next(1, 10);
            this.radLabel1.Text =student.Id+"" ;
        }
    }
}